local WMS = WMS_016

function WMS:CreateCom()
  if (not self.COM) then
    self.COM = {}
    local COM = self.COM 

    local ADDON_MSG_PREFIX = "WMS-016"
    local success = C_ChatInfo.RegisterAddonMessagePrefix(ADDON_MSG_PREFIX); 
    
    function COM:encode(s)
        local encoded = ""
        for i = 1, string.len(s) do
            local n = string.byte(s, i, i)
            encoded = encoded .. string.format("%02X", n)
        end
        return encoded
    end

    function COM:decode(encoded)
        local decoded = ""
        for i = 1, string.len(encoded) / 2 do
            local start = i * 2 - 1
            local hex = string.sub(encoded, start, start + 1)
            local n = tonumber(hex, 16)
            local c = string.char(n)
            decoded = decoded .. c
        end
        return decoded
    end

    function COM:SendMsg(msg_code, msg, receiver)
      --print ("SendMsg msg_code:", msg_code," msg:", msg, " Receiver:", receiver)
      if (msg_code and msg and receiver) then
        local encoded = self:encode(msg)
        C_ChatInfo.SendAddonMessage(ADDON_MSG_PREFIX, msg_code..":"..encoded, "WHISPER", receiver)
      end
    end

    function COM:OnRawMsg(prefix, rawMessage , channel, sender)
      if (prefix == ADDON_MSG_PREFIX) then 
        local endOfPrefix, startOfBody = string.find(rawMessage, ":")
        local msgPrefix = string.sub(rawMessage, 1, endOfPrefix - 1)
        local msgBody = string.sub(rawMessage, startOfBody + 1)
        local decoded = COM:decode(msgBody)
        WMS:OnMessage(msgPrefix, decoded, sender)
      end 
    end
  end
  
  return self.COM
end

